/*******************************************************************************
 *	BHtml		HTML Generation classes
 *			T.Barnaby,	BEAM Ltd,	2006-09-03
 *******************************************************************************
 */
#include <BList.h>

#ifndef BHtml_h
#define BHtml_h 1

#include <BString.h>

typedef void (*HtmlWriteFunc)(const BString& str);

class BHtml {
public:
			BHtml(const BString& tag = "", const BString& args = "", const BString& text = "");
			~BHtml();
			
	BHtml*		append(const BHtml& node);
	BHtml*		append(const BString& tag = "", const BString& args = "", const BString& text = "");
	BHtml*		appendText(const BString& text);

	BHtml*		appendFormField(BString name, BString title, BString type, BString param, BString value, BString arg = "", int submit = 0);
	void		appendFormItem(BString name, BString title, BString type, BString param, BString value);
	
	void		render(HtmlWriteFunc writeFunc);
	BString		render();

private:
	BString		otag;
	BString		oargs;
	BList<BHtml>	nodes;
};

BString urlEncode(BString str);
BString urlDecode(BString str);

#endif
